/* Copyrigth 1993-95 H.Ogasawara (COR.) */

#ifndef UNIX
# define	UNIX		1
# define	BINARY_OPEN	0
#endif

/* ============================================= */
/* Normal - file I/O rourtine */
#include	"emu_fio.h"
#include	<stdlib.h>

#if BINARY_OPEN
# define		BROPEN		"rb"
# define		BWOPEN		"wb"
# define		BRWOPEN		"r+b"
#else
# define		BROPEN		"r"
# define		BWOPEN		"w"
# define		BRWOPEN		"r+"
#endif

#ifndef TRUE
# define	TRUE		1
# define	FALSE		0
#endif


Mputchar( ch )
char	ch;
{
#if UNIX
	if( ch == '\r' )
		return;
#endif
	putchar( ch );
}

Merrch( ch )
char	ch;
{
#if UNIX
	if( ch == '\r' )
		return;
#endif
	putc( ch, stderr );
}


Mprint( ptr )
char	*ptr;
{
	for(; *ptr ; Mputchar( *ptr++ ) );
}

Merr( ptr )
char	*ptr;
{
	for(; *ptr ; Merrch( *ptr++ ) );
}

Mopen( fm, name )
m_file	*fm;
char	*name;
{
	if( *name == '-' && !name[1] ){
		fm->fp= stdin;
		fm->fn= fileno( stdin );
		return	TRUE;
	}else if( fm->fp= fopen( name, BROPEN ) ){
		fm->fn= fileno( fm->fp );
		return	TRUE;
	}
	return	FALSE;
}

Mcreate( fm, name )
m_file	*fm;
char	*name;
{
	if( *name == '-' && !name[1] ){
		fm->fp= stdout;
		fm->fn= fileno( stdout );
		return	TRUE;
	}else if( fm->fp= fopen( name, BWOPEN ) ){
		fm->fn= fileno( fm->fp );
		return	TRUE;
	}
	return	FALSE;
}

Mappend( fm, name )
m_file	*fm;
char	*name;
{
	if( access( name, 0 /*F_OK*/ ) < 0 )
		return	Mcreate( fm, name );
	if( fm->fp= fopen( name, BRWOPEN ) ){
		fm->fn= fileno( fm->fp );
		return	TRUE;
	}
	return	FALSE;
}

Mclose( fm )
m_file	*fm;
{
	if( fm->fp != stdin && fm->fp != stdout )
		return	fclose( fm->fp );
	return	TRUE;
}

Mread( fm, buf, len )
m_file	*fm;
char	*buf;
{
	int	size= fread( buf, 1, len, fm->fp );
	return	size;
}

Mwrite( fm, ptr, len )
m_file	*fm;
char	*ptr;
{
	return	fwrite( ptr, 1, len, fm->fp ) >= len;
}

Mgetc( fm )
m_file	*fm;
{
	return	fgetc( fm->fp );
}

Mputc( fm, ch )
m_file	*fm;
{
	fputc( ch, fm->fp );
}


#define	RDBUFSIZE	(1024*1)
Mgets( fm, buf, len )
m_file	*fm;
unsigned char	*buf;
{
	unsigned char	readbuf[RDBUFSIZE];
	if( fgets( readbuf, RDBUFSIZE, fm->fp ) ){
		unsigned char	*str= buf, *ptr= readbuf;
		int		len= 0;
		for(; *ptr && *ptr != '\r' && *ptr != '\n' ; len++ )
			*str++= *ptr++;
		*str= '\0';
		return	len;
	}
	return	-1;
}

Mputs( fm, ptr )
m_file	*fm;
char	*ptr;
{
#if UNIX
	for(; *ptr ; ptr++ ){
		if( *ptr != '\r' )
			putc( *ptr, fm->fp );
	}
#else
	fputs( ptr, fm->fp );
#endif
	return	TRUE;
}

Mflush( fm )
m_file	*fm;
{
	fflush( fm->fp );
}

Mseek( fm, pos, mode )
m_file	*fm;
{
	fseek( fm->fp, pos, mode );
}

static int	_F_Length= 0;

void *
MallocReadOffset2( file, t0, t1 )
char	*file;
{
	FILE	*fp;
	if( fp= fopen( file, BROPEN ) ){
		int	len;
		char	*ptr;
		fseek( fp, 0, 2 );
		len= ftell( fp );
		fseek( fp, 0, 0 );
		if( ptr= malloc( _F_Length= len+t0+t1 ) ){
			fread( ptr+t0, 1, len, fp );
			fclose( fp );
			return	ptr;
		}
		fclose( fp );
	}
	return	NULL;
}
void *
MallocRead( file )
char	*file;
{
	return	MallocReadOffset2( file, 0, 0 );
}
void *
MallocReadOffset( file, off )
char	*file;
{
	return	MallocReadOffset2( file, 0, off );
}
void *
MallocReadTopOffset( file, off )
char	*file;
{
	return	MallocReadOffset2( file, off, 0 );
}
MallocSize()
{
	return	_F_Length;
}

McreateWrite( file, ptr, length )
char	*file, *ptr;
{
	FILE	*fp;
	if( fp= fopen( file, BWOPEN ) ){
		length= fwrite( ptr, 1, length, fp );
		fclose( fp );
		return	length;
	}
	return	0;
}

/* ============================================= */
