/* iofunc.c  X680x0/UNIX Copyright 1995 H.Ogasawara(COR.) */

/*===============================================================*/
#if HUMAN68K

#include	<sys_doslib.h>
#include	"iofunc.h"
#include	"oproto.h"

int	zio_TimeOut;

Error( msg1, msg2 )
char	*msg1, *msg2;
{
	PRINT( msg1 );
	PRINT( msg2 );
	PRINT( "\r\n" );
}

BreakInput()
{
	return	INPOUT( 0xff ) == 0x1b;
}

RsInit( speed )
{				/*	    9600    19200   OPT(9600)	*/
	static unsigned short	param[3]= { 0x4c87, 0x4c88, 0x5c07 };
	SET232C( param[speed] );
	RsClear();
	if( speed == 2 )
		OpticalMode= 1;
}

RsClear()
{
	int	i= LOF232C();
	for(; i-- ; INP232C() );
}

static int	wait_time;

BreakCheck()
{
	if( BreakInput() ){
		Error( "f܂", "" );
		SysExit( 1 );
	}
	if( SysClock() > wait_time ){
		zio_TimeOut= 1;
		return	TIMEOUT;
	}
	return	0;
}

TimeOutError()
{
	Error( "^CAEg", "" );
	SysExit( 1 );
}

RsRecvCode( time )
{
	zio_TimeOut= 0;
	wait_time= SysClock()+time;
	for(; !RsRecvCheck() ;)
		if( BreakCheck() )
			return	TIMEOUT;
	return	RsRecv();
/*{
int i;
v_format_put( "r %x\r\n", i= RsRecv() );
return	i;
}*/
}

RsSendCode( time, code )
unsigned char	code;
{
	zio_TimeOut= 0;
	wait_time= SysClock()+time;
	for(; !RsSendCheck() ;)
		if( BreakCheck() )
			return	TIMEOUT;
	RsSend( code );
/*v_format_put( "s %x\r\n", code );*/
	return	0;
}

SysSleep( time )
{
	int	t= SysClock()+time/10+2;
	for(; SysClock() > t ;);
}

void *
SysAlloc( size )
{
	unsigned char	*ptr= MALLOC( size );
	if( (int)ptr >= 0 )
		return	ptr;
	return	0;
}

#endif


/*===============================================================*/
#if UNIX

#ifndef DEFAULT_DEVICE
# if SUN_OS4
#  define	DEFAULT_DEVICE	"/dev/ttya"
# else
#  define	DEFAULT_DEVICE	"/dev/tty00"
# endif
#endif
#ifndef SPEED_19200
#  define	SPD_19200	B19200
#endif
#ifndef TERM_IOS
# define	TERM_IOS	1
#endif

#include	<stdio.h>
#if TERM_IOS
# include	<termios.h>
#else
# include	<sgtty.h>
# include	<sys/ioctl.h>
#endif
#include	<signal.h>
#include	<sys/types.h>
#include	<sys/time.h>
#include	<sys/file.h>
#include	<sys/param.h>

#if !TERM_IOS
# if HP_UX	/* HP-UX ? */
# include	<bsdtty.h>
# define	CBREAK		0
# define	TANDEM		0
# endif
#endif

#include	"iofunc.h"
#include	"oproto.h"

#define		IOBUFSIZE	(1024*2)

static fd_set		fdbuf;
static struct timeval	timeout= { 0, 0 };
static int		rsfn;
static unsigned char	i_buf[IOBUFSIZE],
			*i_ptr= i_buf,
			*i_end= i_buf;
char			ttydevice[256]= DEFAULT_DEVICE;
#if TERM_IOS
struct termios		ottyarg;
#else
struct sgttyb		ottyarg;
static int		oldlocal;
#endif

int			zio_TimeOut;

Print( msg )
char	*msg;
{
	fputs( msg, stderr );
	fflush( stderr );
}

Error( msg1, msg2 )
char	*msg1, *msg2;
{
	fprintf( stderr, "%s%s\n", msg1, msg2 );
}

SysExit( code )
{
	exit( code );
}

SysSleep( time )
{
	usleep( time*1000 );
}

TimeOutError()
{
	Error( "TimeOut", "" );
	RsQuit();
	SysExit( 1 );
}
SysBreak()
{
	Error( "Break", "" );
	RsQuit();
	SysExit( 1 );
}

RsInit( speed )
{

	signal( SIGINT, SysBreak );
	signal( SIGHUP, SysBreak );
	signal( SIGQUIT, SysBreak );

	if( (rsfn= open( ttydevice, O_RDWR )) < 0 ){
		Error( ttydevice, " tty open error" );
		SysExit( 1 );
	}
	{
#if TERM_IOS
	struct termios	ttyarg;
	ioctl( rsfn, TCGETS, &ottyarg );
	ioctl( rsfn, TCGETS, &ttyarg );
	ttyarg.c_cc[VMIN]= 1;
	ttyarg.c_cc[VTIME]= 1;
	ttyarg.c_iflag &= ~(IGNCR|ICRNL|IXON|IXOFF|ISTRIP|IUCLC|IXANY|INPCK);
	ttyarg.c_oflag &= ~(ONLCR|OLCUC|OCRNL|ONOCR|ONLRET|NLDLY|CRDLY|TABDLY);
	ttyarg.c_cflag &= ~(CBAUD|CSIZE|PARENB);
	ttyarg.c_cflag |= (speed == 1 ? SPD_19200 : B9600) |CS8|CREAD;
	ttyarg.c_lflag &= ~(ICANON|ECHO|ECHOE|ECHOK|ISIG|XCASE|ECHONL|PENDIN);
	if( speed == 2 ){
		ttyarg.c_iflag |= INPCK;
		ttyarg.c_cflag |= PARENB|PARODD;
		OpticalMode= 1;
	}
	ioctl( rsfn, TCSETSW, &ttyarg );
#else
	struct sgttyb	ttyarg;
	int		local;
	ioctl( rsfn, TIOCGETP, &ottyarg );
	ioctl( rsfn, TIOCGETP, &ttyarg );
	ttyarg.sg_ispeed= ttyarg.sg_ospeed= speed == 1 ? SPD_19200 : B9600;
	if( speed == 2 ){
		ttyarg.sg_flags|= ODDP;
		OpticalMode= 1;
	}else
		ttyarg.sg_flags&= ~ODDP;
	ttyarg.sg_flags&=~(EVENP|ALLDELAY|CBREAK|LCASE|CRMOD|ECHO|TANDEM);
	ttyarg.sg_flags|= (RAW);
	ioctl( rsfn, TIOCSETP, &ttyarg );
	ioctl( rsfn, TIOCLGET, &local );
	oldlocal= local;
	local|= LPASS8|LPENDIN;
	ioctl( rsfn, TIOCLSET, &local );
# if NEWS_OS4
	ioctl( rsfn, TIOCKGET, &local );
	local= KM_SJIS|KM_SYSSJIS;
	ioctl( rsfn, TIOCKSET, &local );
# endif
#endif	/* TERM_IOS */
	}
}

#if NEWS_OS4
#include <sgtty.h>
#endif
RsClear()
{
#if TERM_IOS && !NEWS_OS4
	ioctl( rsfn, TCFLSH, TCIFLUSH );
#else
	int	flag= FREAD;
	ioctl( rsfn, TIOCFLUSH, &flag );
#endif
}

RsQuit()
{
#if TERM_IOS
	ioctl( rsfn, TCSETSW, &ottyarg );
#else
	ioctl( rsfn, TIOCSETP, &ottyarg );
	ioctl( rsfn, TIOCLSET, &oldlocal );
#endif
	close( rsfn );
}

RsRecvCode( time )
{
	if( i_ptr < i_end )
		return	*i_ptr++;
	timeout.tv_sec=  time/100;
	timeout.tv_usec= time%100*10000;
	for( zio_TimeOut= 0 ;;){
		FD_ZERO( &fdbuf );
		FD_SET( 0, &fdbuf );
		FD_SET( rsfn, &fdbuf );
		if( !select( rsfn+1, &fdbuf, 0, 0, &timeout ) ){
			zio_TimeOut= 1;
			return	TIMEOUT;
		}
		if( FD_ISSET( 0, &fdbuf ) ){
			unsigned char	chbuf;
			read( 0, &chbuf, 1 );
			if( chbuf == 0x1b ){	/* ESC - LF */
				SysBreak();
			}
		}
		if( FD_ISSET( rsfn, &fdbuf ) ){
			i_end= i_buf+read( rsfn, i_ptr= i_buf, IOBUFSIZE );
			if( i_ptr < i_end )
				return	*i_ptr++;
		}
	}
}

RsSendCode( time, code )
{
	unsigned char	ch= code;
	timeout.tv_sec=  time/100;
	timeout.tv_usec= time%100*10000;
	zio_TimeOut= 0;
	do{
		FD_ZERO( &fdbuf );
		FD_SET( rsfn, &fdbuf );
		if( !select( rsfn+1, 0, &fdbuf, 0, &timeout ) ){
			zio_TimeOut= 1;
			return	TIMEOUT;
		}
	}while( !FD_ISSET( rsfn, &fdbuf ) );
	write( rsfn, &ch, 1 );
	return	0;
}
#endif
