/* oproto.c for X680x0 Copyright 1995 H.Ogasawara(COR.) */

#include	"zaddin.h"
#include	"iofunc.h"
#include	"oproto.h"

static unsigned char	OpBuf[Op_PACKET_BUF_SIZE],
			*Op= OpBuf;
int			OpticalMode= FALSE;

unsigned short
CheckSum( length, ptr )
unsigned char	*ptr;
{
	unsigned short	sum= 0;
	for(; length-- ; sum+= *ptr++ );
	return	sum;
}

static void
RsRead( len, str )
unsigned char	*str;
{
	for(; len-- ; *str++= RsRecvCode( 100 ) );
}

unsigned short
RsWord()
{
	unsigned char	buf[2];
	RsRead( 2, buf );
	return	(buf[1]<<8)+buf[0];
}

static void
RsWrite( len, ptr )
unsigned char	*ptr;
{
	for(; len-- ; RsSendCode( 100, *ptr++ ) );
}

OptSend1( code )
{
	static unsigned char	head[]= { 0, 0, 0, 0, 0, 0x96, 0x82 };
	RsWrite( 7, head );
	RsSendCode( 100, code );
	RsClear();
}

OptRecv1()
{
	unsigned char	c;
	int		i;
_Retry:
	do{
		c= RsRecvCode( 50 );
		if( zio_TimeOut )
			return	FATAL;
	}while( c );
	for( i= 0 ; !c ; c= RsRecvCode( 50 ), i++ );
	if( i < 2 )
		goto	_Retry;
	if( c == 0x96 ){
		if( RsRecvCode( 50 ) == 0x82 )
			return	RsRecvCode( 50 );
	}
	goto	_Retry;
}

OptRecvPacket( packet, num )
unsigned char	*packet;
unsigned short	num;
{
	unsigned short	pnum;
	int		i, length;
	unsigned char	c;
_Retry:
	for(; OptRecv1() != cENQ ;);
	SysSleep( 3 );
	OptSend1( cSYN );
_Retry2:
	do{
		c= RsRecvCode( 40 );
		if( zio_TimeOut )
			goto	_Retry;
	}while( c );
	for( i= 0 ; !c ; c= RsRecvCode( 50 ), i++ );
	if( i < 2 )
		goto	_Retry2;
	if( c != 0x96 )
		goto	_Retry2;
	if( RsRecvCode( 50 ) != 0x81 ){
		Error( "Packet format error", "" );
		goto	_Retry;
	}
	RsRecvCode( 50 );	/* 0x10 */
	pnum= RsWord();
	if( pnum != 0xffff && pnum != num ){
		Error( "packet number error", "" );
		goto	_Retry;
	}
	RsRecvCode( 50 );	/* 0x01 */
	RsRecvCode( 50 );	/* 0x40 */
	RsRecvCode( 50 );	/* 0xfe */
	length= RsWord();
	RsRead( length, packet );
	if( RsWord() != CheckSum( length, packet ) ){
		Error( "check sum error", "" );
		OptSend1( cNACK );
		goto	_Retry;
	}
	OptSend1( cACK );
/*	SysSleep( 3 );*/
	return	pnum == 0xffff ? length+ 0x1000 : length ;
}

OptSendPacket( length, num, packet )
unsigned short	num;
unsigned char	*packet;
{
	static unsigned char	buf[16]= {
			0x00, 0x00, 0x00, 0x00, 0x00, 0x96, 0x81, 0x10,
			0x00, 0x00, 0x01, 0x40, 0xfe, 0x00, 0x00 };
	unsigned short	check_sum;
	do{
		do{
			OptSend1( cENQ );
		}while( OptRecv1() != cSYN );
		buf[8]= num;
		buf[9]= num>>8;
		buf[13]= length;
		buf[14]= length>>8;
		RsWrite( 15, buf );
		RsWrite( length, packet );
		check_sum= CheckSum( length, packet );
		buf[8]= check_sum;
		buf[9]= check_sum>>8;
		RsClear();
		RsWrite( 2, buf+8 );
	}while( OptRecv1() != cACK );
	return	TRUE;
}

OptRecvOpen()
{
	if( OpticalMode ){
		OptRecvPacket( OpBuf, -1 );
		Op= OpBuf;
	}
}
OptSendOpen()
{
	Op= OpBuf;
}
OptSendFlush()
{
	if( OpticalMode )
		OptSendPacket( Op-OpBuf, -1, OpBuf );
}

RecvData( len, str )
unsigned char	*str;
{
	if( OpticalMode ){
		for(; len-- ; *str++= *Op++ );
	}else{
		for(; len-- ; *str++= RsRecvCode( 10*100 ) )
			if( zio_TimeOut )
				TimeOutError();
	}
}

SendData( len, ptr )
unsigned char	*ptr;
{
	if( OpticalMode ){
		for(; len-- ; *Op++= *ptr++ );
	}else{
		for(; len-- ; RsSendCode( 10*100, *ptr++ ) )
			if( zio_TimeOut )
				TimeOutError();
	}
}

