/* zaddin.c for X680x0 */

#include	"emu_fio.h"
#include	"emu_str.h"
#include	"zaddin.h"
#include	"iofunc.h"

#define		PACKET_SIZE	(1024*2)
#define		LINEBUF		(1024)

int	OptSpeed= DEF_SPEED,
	OptText= FALSE,
	OptReset= TRUE,
	OptQuick= FALSE,
	OptDoc= TRUE;

OpenZaurus()
{
	unsigned char	packet_buf[PACKET_SIZE];

	SendCommand( 3, "CFV" );
	RecvCommand( packet_buf );
	if( n_fstrcmp( "DOK", packet_buf ) ){
		Error( "Zaurus ڑ܂͑ҋ@Ԃɂ܂", "" );
		return	FALSE;
	}
	WaitCode( cENQ );

	SendCommand( 20, "RFV\012\000\000S1:NIFADR.BOX" );
	RecvCommand( packet_buf );
	if( n_fstrcmp( "AFV", packet_buf ) ){
		Error( "addin @\͎gpł܂", "" );
		return	FALSE;
	}
	return	TRUE;
}

CloseZaurus()
{
	unsigned char	packet_buf[PACKET_SIZE];

	if( OptReset ){
		WaitCode( cENQ );
		ResetZaurus();
	}
	ExitZaurus();
	return	TRUE;
}

#if UNIX
#  define	DTP	(128-3)
# else
#  define	DTP	(256-3)
#endif
#define		GAP	(1024*64)

SendZaurus( fname )
char	*fname;
{
#if 0
	unsigned char	*ptr;
	WaitCode( cENQ );
	if( ptr= MallocReadOffset( fname, GAP ) ){
		int	length= MallocSize( ptr )-GAP;
		unsigned char	*p= (unsigned char*)fname;
		for(; *p ; p++ ){	/* toupper */
			if( *p >= 'a' && *p <= 'z' )
				*p^= 0x20;
		}
		if( OptText ){
			for( p= ptr ; p < p+length ; p++ ){
				if( 
			}
		}
		Print( fname );
		Print( ":" );
		SendFileData( length, ptr, fname );
		SysFree( ptr );
		return	TRUE;
	}else{
		Error( fname, ":file open error" );
	}
	return	FALSE;
#else
	unsigned char	packet_buf[PACKET_SIZE];
	m_file	fm;

	WaitCode( cENQ );
	SendCommand( 3, "CFD" );
	RecvCommand( packet_buf );
	if( n_fstrcmp( "DOK", packet_buf ) ){
		Error( "MR}hG[", "" );
		return	FALSE;
	}

	if( !Mopen( &fm, fname ) ){
		Error( fname, ":Mt@CI[vł܂" );
		return	FALSE;
	}

	Print( fname );
	Print( ":" );

	WaitCode( cENQ );
	{
		int	length,
			i= 1;
		{
			unsigned char	*p= (unsigned char*)fname;
			for(; *p ; p++ ){	/* toupper */
				if( *p >= 'a' && *p <= 'z' )
					*p^= 0x20;
			}
		}
		s_strcpy( s_strcpy( packet_buf, "RFDS1:" ), fname );
		do{
			SendPacket( n_strlen(fname)+7, i++, packet_buf );
		}while( Recv1byte() != cACK );
		do{
			s_strcpy( packet_buf, "RFD" );
			if( length= Mread( &fm, packet_buf+3, DTP ) ){
#if UNIX
				unsigned char	packet_work[PACKET_SIZE];
				if( OptText ){
					unsigned char	*p= packet_buf+3,
							*s= packet_work;
					for(; p < packet_buf+3+length ;){
						if( *p == '\n' )
							*s++= '\r';
						*s++= *p++;
					}
					length= s-packet_work;
					s_memcpy_simple( length, packet_buf+3,
								packet_work );
				}
#endif
				do{
					Print( "o" );
					SendPacket(length+3, i++, packet_buf );
				}while( Recv1byte() != cACK );
			}
		}while( length >= DTP );
		if( OptText ){
			Print( "T" );
			packet_buf[3]= 0x1a;
			do
				SendPacket( 4, i, packet_buf );
			while( Recv1byte() != cACK );
			OptText= FALSE;
		}
	}

	Mclose( &fm );

	do{
		Send1byte( cET );
	}while( Recv1byte() != cACK );

	RecvCommand( packet_buf );
	if( n_fstrcmp( "AEX", packet_buf ) ){
		Error( fname, ":MɎs܂" );
		return	FALSE;
	}
	Error( " I", "" );
	return	TRUE;
#endif
}

PrintHead( fname )
char	*fname;
{
	m_file	fm;
	unsigned char	linebuf[LINEBUF];
	if( Mopen( &fm, fname ) ){
		int	i= 0;
		for(; i++< 5 && Mgets( &fm, linebuf, LINEBUF ) >= 0 ;)
			Error( linebuf, "" );
		Mclose( &fm );
	}
	Error( "--", "" );
}

AddinQuickZaurus( file )
char	*file;
{
	RsInit( OptSpeed );
	if( OpenZaurus() ){
		SendZaurus( file );
		Error( "M", "" );
		CloseZaurus();
	}
}

AddinZaurus( zrs_file )
char	*zrs_file;
{
	m_file	fm;
	unsigned char	linebuf[LINEBUF];
	if( Mopen( &fm, zrs_file ) ){
		Mgets( &fm, linebuf, LINEBUF );
		if( !n_fstrcmp( "ZRS,P,", linebuf ) ){
			Error( "","" );
			Error( "^Cg ", linebuf+6 );
			Mgets( &fm, linebuf, LINEBUF );
			if( OptDoc )
				PrintHead( linebuf );
			RsInit( OptSpeed );
			if( OpenZaurus() ){
				for(; Mgets( &fm, linebuf, LINEBUF ) >= 0 ;){
					if( *linebuf != 0x1a )
						SendZaurus( linebuf );
				}
				Error( "M",
						" Zaurus{̂ċN܂" );
				CloseZaurus();
			}
		}else{
			Error( zrs_file, ":tH[}bgG[" );
		}
		Mclose( &fm );
	}else{
		Error( zrs_file, ":I[vł܂" );
	}
}

main( argc, argv )
char	**argv;
{
	char	*file= 0;
	Error( "zaddin v1.41 ZAURUS AddIn\tg]", " 1996 COR." );
	for(; --argc ;){
		if( **++argv == '-' && (*argv)[1] ){
			switch( (*argv)[1] ){
			case 's':
				OptSpeed= (*argv)[2]&3;
				continue;
			case 't':
				OptText= TRUE;
				continue;
			case 'R':
				OptReset= FALSE;
				continue;
			case 'q':
				OptQuick= TRUE;
				continue;
			case 'D':
				OptDoc= FALSE;
				continue;
#if UNIX
			case 'd':
				DEV_SWITCH();
#endif
			default:
				file= 0;
			}
			break;
		}else
			file= *argv;
	}
	if( file ){
		if( !OptQuick )
			AddinZaurus( file );
		else
			AddinQuickZaurus( file );
	}else{
		Error( "usage: ", "zaddin    [-s0|1|2] [-t] [-D] <file>.zrs" );
		Error( "       ", "zaddin -q [-s0|1|2] [-t] [-R] <file>.bas" );
	}
	SysExit( 0 );
}
