/* Copyright 1995 H.Ogasawara (COR.) */

#include	"emu_str.h"
#include	"emu_fio.h"
#include	"iofunc.h"
#include	"hex.h"

#ifndef TRUE
# define	TRUE	1
# define	FALSE	0
#endif

static unsigned char	code0[]= {
	hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF, hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF,
	hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF, hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF,
/**/
	hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF, hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF,
	h00,h01,h02,h03,h04,h05,h20,h21, h22,h23,h24,h25,hFF,hFF,hFF,hFF,
	hFF,h06,h07,h08,h09,h0A,h0B,h0C, h0D,h0E,h0F,h10,h11,h12,h13,h14,
	h15,h16,h17,h18,h19,h1A,h1B,h1C, h1D,h1E,h1F,hFF,hFF,hFF,hFF,hFF,
	hFF,h26,h27,h28,h29,h2A,h2B,h2C, h2D,h2E,h2F,h30,h31,h32,h33,h34,
	h35,h36,h37,h38,h39,h3A,h3B,h3C, h3D,h3E,h3F,hFF,hFF,hFF,hFF,hFF,
/**/
	hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF, hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF,
	hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF, hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF,
	hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF, hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF,
	hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF, hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF,
	hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF, hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF,
	hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF, hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF,
	hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF, hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF,
	hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF, hFF,hFF,hFF,hFF,hFF,hFF,hFF,hFF,
};

static unsigned char	codeA[]= {
	h00,h00,h00,h00,h00,h00,h00,h00, h00,h00,h00,h00,h00,h00,h00,h00,
	h40,h40,h40,h40,h40,h40,h40,h40, h40,h40,h40,h40,h40,h40,h40,h40,
	h80,h80,h80,h80,h80,h80,h80,h80, h80,h80,h80,h80,h80,h80,h80,h80,
	hC0,hC0,hC0,hC0,hC0,hC0,hC0,hC0, hC0,hC0,hC0,hC0,hC0,hC0,hC0,hC0,
}, codeB[]= {
	h00,h00,h00,h00,h40,h40,h40,h40, h80,h80,h80,h80,hC0,hC0,hC0,hC0,
	h00,h00,h00,h00,h40,h40,h40,h40, h80,h80,h80,h80,hC0,hC0,hC0,hC0,
	h00,h00,h00,h00,h40,h40,h40,h40, h80,h80,h80,h80,hC0,hC0,hC0,hC0,
	h00,h00,h00,h00,h40,h40,h40,h40, h80,h80,h80,h80,hC0,hC0,hC0,hC0,
}, codeC[]= {
	h00,h40,h80,hC0,h00,h40,h80,hC0, h00,h40,h80,hC0,h00,h40,h80,hC0,
	h00,h40,h80,hC0,h00,h40,h80,hC0, h00,h40,h80,hC0,h00,h40,h80,hC0,
	h00,h40,h80,hC0,h00,h40,h80,hC0, h00,h40,h80,hC0,h00,h40,h80,hC0,
	h00,h40,h80,hC0,h00,h40,h80,hC0, h00,h40,h80,hC0,h00,h40,h80,hC0,
};

static unsigned char *
Decode3( a, b, c, d, str )
unsigned char	a, b, c, d, *str;
{
	a= code0[a];
	b= code0[b];
	c= code0[c];
	d= code0[d];
	if( c == 0xff ){
		*str++= a+ codeA[b];
	}else if( d == 0xff ){
		*str++= a+ codeA[c];
		*str++= b+ codeB[c];
	}else{
		*str++= a+ codeA[d];
		*str++= b+ codeB[d];
		*str++= c+ codeC[d];
	}
	return	str;
}

static unsigned char *
DecodeLine( length, str, ptr )
unsigned char	*str, *ptr;
{
	for(; length > 0 ; length-= 4 ){
		unsigned char	a, b, c, d;
		a= *ptr++;
		b= *ptr++;
		c= *ptr++;
		d= *ptr++;
		str= Decode3( a, b, c, d, str );
	}
	return	str;
}


/****/

typedef struct {
	unsigned char	fname[12],
			attr,		/*?*/
			time[2],	/*?*/
			date[2],	/*?*/
			size[3];
} T_DIR;

#define		MAXENT		512
#define		BUF_LENGTH	1024

static int	Continue= FALSE,
		ListOnly= FALSE,
		TitleList= FALSE;

static struct {
	unsigned char	dummy[6];
	T_DIR	idx[MAXENT];
} index_buf;

FileName( name )
unsigned char	*name;
{
	int	i;
	unsigned char	*s= name, *p= name;
	for( i= 0 ; i< 12 ; i++, p++ ){
		if( *p != ' ' )
			*s++= *p;
	}
	*s= '\0';
}

DecodeFile( fm, str )
m_file	*fm;
unsigned char	*str;
{
	unsigned char	i_buf[BUF_LENGTH], *top= str;
	int		len;
	Continue= 0;
	for(; (len= Mgets( fm, i_buf, BUF_LENGTH ))>= 0 ;){
		if( !n_fstrcmp( "PABAK", i_buf ) )
			continue;
		if( *i_buf == 0x1a ){
			if( !n_fstrcmp( "PABAK", i_buf+1 ) )
				Continue= TRUE;
			return	str-top;
		}
		str= DecodeLine( len, str, i_buf );
	}
	return	str-top;
}

DecodeBackup( file )
char	*file;
{
	m_file	fm;
	if( Mopen( &fm, file ) ){
		T_DIR	*dp;
		int	len;
		len= DecodeFile( &fm, &index_buf )/sizeof(T_DIR);
		dp= index_buf.idx;
		for(; len-- ; dp++ ){
			char	*ptr;
			int	size, fsize= dp->size[0]+(dp->size[1]<<8)+
							(dp->size[2]<<16);
			FileName( dp->fname );
			if( !Continue ){
				Mprint( "f[^\܂\r\n" );
				break;
			}
			{
				char	o_buf[256], *s= o_buf;
				if( !TitleList ){
					s= s_strnumi( fsize, 8, o_buf );
					*s++= ' ';
					*s++= ' ';
				}
				s_strcpy( s, dp->fname );
				Mprint( o_buf );
				Mprint( "\r\n" );
			}
			if( ptr= SysAlloc( fsize*2 ) ){
				size= DecodeFile( &fm, ptr );
				if( size != fsize )
					Merr( "TCY܂\r\n" );
				else if( !ListOnly )
					McreateWrite( dp->fname, ptr, size );
				SysFree( ptr );
			}else{
				Merr( "G[\r\n" );
			}
		}
		Mclose( &fm );
		return	TRUE;
	}
	return	FALSE;
}

main( argc, argv )
char	**argv;
{
	char	*fname= 0;
	for(; --argc ;){
		if( **++argv == '-' && (*argv)[1] ){
			switch( (*argv)[1] ){
			case 't':
				TitleList= TRUE;
			case 'l':
				ListOnly= TRUE;
				continue;
			default:
				fname= 0;
			}
			break;
		}else
			fname= *argv;
	}
	if( !TitleList )
		Mprint(
		"zbackdump v1.4 obNAbvt@C؂o 1995 COR.\r\n");
	if( fname ){
		DecodeBackup( fname );
	}else{
		Merr( "usage: zbackdump [-l] <backupfile>\r\n" );
	}
	return	0;
}
